﻿Imports Infragistics.Win
Imports DataGridFocusTest.My.Resources
Imports System.IO
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        InitGrid()
    End Sub

    Private Sub InitGrid()
        'grd.DrawFilter = New NoFocusRectangle

        'Grid settings
        With grd.DisplayLayout
            .LoadStyle = UltraWinGrid.LoadStyle.PreloadRows

            .Override.AllowAddNew = UltraWinGrid.AllowAddNew.No
            .Override.AllowDelete = DefaultableBoolean.False
            .Override.AllowUpdate = DefaultableBoolean.False
            .Override.CellClickAction = UltraWinGrid.CellClickAction.RowSelect
            .Override.DefaultRowHeight = 22
            .Override.SelectTypeRow = UltraWinGrid.SelectType.Single
            .Override.CellAppearance.TextVAlign = VAlign.Middle
            .GroupByBox.Hidden = False
            .GroupByBox.Prompt = "Sleep een kolom hier naar toe om op die kolom te groeperen."
            .AutoFitStyle = UltraWinGrid.AutoFitStyle.ResizeAllColumns
            .PerformAutoResizeColumns(False, UltraWinGrid.PerformAutoSizeType.AllRowsInBand)
        End With
        grd.KeepFocusSelectedWhenGroupedBy("code")

    End Sub

    Public Class NoFocusRectangle
        Implements Infragistics.Win.IUIElementDrawFilter

        Public Function DrawElement(ByVal drawPhase As Infragistics.Win.DrawPhase, ByRef drawParams As Infragistics.Win.UIElementDrawParams) As Boolean Implements Infragistics.Win.IUIElementDrawFilter.DrawElement
            Return True
        End Function

        Public Function GetPhasesToFilter(ByRef drawParams As Infragistics.Win.UIElementDrawParams) As Infragistics.Win.DrawPhase Implements Infragistics.Win.IUIElementDrawFilter.GetPhasesToFilter
            Return Infragistics.Win.DrawPhase.BeforeDrawFocus
        End Function
    End Class

    Private Sub btnFillData_Click(sender As Object, e As EventArgs) Handles btnFillData.Click
        Dim data = New TestData.TestDataDataTable
        For idx1 = 0 To 10
            For idx2 = 1 To 50
                Dim code = idx1 * 100 + idx2
                Dim ms As New MemoryStream
                Select Case code Mod 4
                    Case 0
                        Dim img As Image = Icons_Standard.excel16.ToBitmap
                        img.Save(ms, System.Drawing.Imaging.ImageFormat.Png)
                    Case 1
                        Dim img As Image = Icons_Standard.pdf16.ToBitmap
                        img.Save(ms, System.Drawing.Imaging.ImageFormat.Png)
                    Case 2
                        Dim img As Image = Icons_Standard.msg16.ToBitmap
                        img.Save(ms, System.Drawing.Imaging.ImageFormat.Png)
                    Case 3
                        Dim img As Image = Icons_Standard.afbeelding16.ToBitmap
                        img.Save(ms, System.Drawing.Imaging.ImageFormat.Png)
                End Select
                data.AddTestDataRow(ms.ToArray, String.Format("{0}", code Mod 4), code, String.Format("info 1 = {0}", idx1), String.Format("info 2 = {0}", idx2), String.Format("info1 = {0} and info2 = {1}", idx1, idx2))
            Next
        Next
        grd.DataSource = data
    End Sub


    Private Sub grd_InitializeLayout(sender As Object, e As UltraWinGrid.InitializeLayoutEventArgs) Handles grd.InitializeLayout
        If Not grd.DisplayLayout.Bands(0).Columns.Exists("icon") Then grd.DisplayLayout.Bands(0).Columns.Insert(0, "icon")
        With grd.DisplayLayout.Bands(0).Columns("icon")
            .Style = UltraWinGrid.ColumnStyle.Image
            .SortComparer = New srtComparerTypeDoc
            .MinWidth = 25
            .MaxWidth = 25
            .CellAppearance.ForegroundAlpha = Alpha.Transparent
        End With
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        If IsNothing(grd.DataSource) Then Exit Sub
        With grd.DisplayLayout.Bands(0)
            If .SortedColumns.Exists("info1") Then
                .SortedColumns.Remove("info1")
            Else
                .SortedColumns.Add("info1", False, True)
            End If

        End With
    End Sub

End Class
